/*
 * clock.c
 *
 * Simple Uhrenfunktionen (Uhr zaehlt immer herunter bis Null)
 *
 * Created: 16.08.2013
 *  Author: Nicolas (www.DL1DOW.de)
 */  

// Verzoegerung zum Aufruf von clock_tick auf eine Sekunde
#define CLOCK_DELAY 250 // uint8_t 


#include <avr/io.h> // uintX_t


static uint16_t sgl_clock = 0;
static uint8_t sgl_isclockrunning = 1;


// Uhr ticken lassen (Fuer timer interrupt)
void clock_tick(void) {
  static uint8_t clk_delay = CLOCK_DELAY;
  
  // Wenn die Uhr nicht lauft, Hemmung ruecksetzen und beenden
  if (sgl_isclockrunning==0) {
    clk_delay = CLOCK_DELAY;
    return;
  }

  // Sekundentick
  clk_delay--;
  if (clk_delay==0) {
    clk_delay = CLOCK_DELAY;
    if (sgl_clock > 0) sgl_clock--;
  }
} // clock_tick


uint16_t clock_get(void) { return sgl_clock; }      // Uhr lesen
void clock_set(uint16_t clk) { sgl_clock = clk; }   // Uhr stellen 
void clock_start(void) { sgl_isclockrunning = 1; }  
void clock_stop(void)  { sgl_isclockrunning = 0; }